// excep.cpp
// Glenn G. Chappell
// 29 Oct 2013
//
// For CS 202 Fall 2013
// Demo of Exceptions

#include <iostream>
using std::cin;
using std::cout;
using std::endl;
#include <stdexcept>
using std::invalid_argument;
#include <string>
using std::string;
using std::getline;
#include <sstream>
using std::istringstream;


// readArray
// Simulated array with indices 0, 1, 2.
// Corresponding values: 2, 4, 10.
// Throws invalid_argument on bad index.
int readArray(int index)
{
    int value = 0;
    switch (index)
    {
    case 0:
        value = 2;
        break;
    case 1:
        value = 4;
        break;
    case 2:
        value = 10;
        break;
    default:
        throw invalid_argument("readArray: index out of range");
        break;
    }
    return value;
}


// printVal
// Given array index, calls readArray and prints results.
// If readArray throws, then prints error message.
// Does not throw.
void printVal(int index)
{
    try
    {
        cout << "Array value at index " << index << " is "
             << readArray(index) << endl;
    }
    catch (invalid_argument & e)
    {
        cout << "ERROR" << endl;
        cout << "Message: " << e.what() << endl;
    }
}


// Main program
// Repeatedly input an array index and call printVal with it.
int main()
{
    while (true)
    {
        cout << endl;
        cout << "Array index (blank line to end): ";
        string line;
        getline(cin, line);
        if (!cin)
            break;
        if (line == "")
            break;
        istringstream instr(line);
        int n;
        instr >> n;
        if (!instr)
        {
            cout << "Please type an integer" << endl;
            continue;
        }
        printVal(n);
    }

}

